<template>
  <div class="app-container project-standard-index">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="项目" prop="projectId">        
        <el-select v-model="queryParams.projectId" filterable  placeholder="请选择项目" clearable @change="doQuerySub">
          <el-option v-for="(item, index) in projectOptions" :key="index" :label="item.projectName" :value="item.id">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="总包单位" prop="deptId">
        <el-select v-model="queryParams.deptId" filterable placeholder="请选择总包单位" clearable>
          <el-option v-for="(item, index) in depts" :key="index" :label="item.deptName" :value="item.deptId">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="图片描述" prop="standardDesc">
        <el-input v-model="queryParams.standardDesc" placeholder="请输入图片描述" clearable
          @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="类型" prop="ord">
        <div style="display: inline-block;width:200px;">
        <treeselect v-model="queryParams.standardType" :options="options" :show-count="true"  placeholder="请选择类型"/>  
      </div>
      </el-form-item>
      
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8" v-if="1==2">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd" 
          v-hasPermi="['project:projectStandard:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate"
          v-hasPermi="['project:projectStandard:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['project:projectStandard:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport"
          v-hasPermi="['project:projectStandard:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="projectStandardList" @selection-change="handleSelectionChange" stripe>
      <el-table-column type="selection" width="55" align="center" v-if="1==2"/>      
      <el-table-column label="项目" align="center" prop="remark" />
      <el-table-column label="总包单位" align="center" prop="deptName" />
      <el-table-column label="图片路径" align="center" prop="imageFile">
        <template slot-scope="{row}">
          <el-image v-if="row.imageFile" class="row-image" :src="row.imageFile + '.min.jpg'"
            :preview-src-list="[row.imageFile]"></el-image>
        </template></el-table-column>
      <el-table-column label="图片描述" align="center" prop="standardDesc" />     
      <el-table-column label="类型" align="center" prop="standardType" class-name="td-tree-select">
        <template slot-scope="{row}">
          <treeselect v-model="row.standardType" :options="options" :show-count="true"  placeholder="请选择类型"  @select="a=>doRowSelect(row,a)"/>  
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleEdit(scope.row)" v-hasPermi="['project:projectStandard:edit']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
            v-hasPermi="['project:projectStandard:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改标准化管理对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body :close-on-click-modal="false"
      :close-on-press-escape="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="项目" prop="projectId">
          <el-input v-model="form.projectId" placeholder="请输入项目ID" />
        </el-form-item>
        <el-form-item label="总包单位" prop="deptId">
          <el-input v-model="form.deptId" placeholder="请输入总包单位" />
        </el-form-item>
        <el-form-item label="图片路径" prop="imageFile">
          <file-upload v-model="form.imageFile" />
        </el-form-item>
        <el-form-item label="图片描述" prop="standardDesc">
          <el-input v-model="form.standardDesc" placeholder="请输入图片描述" />
        </el-form-item>
        <el-form-item label="排序" prop="ord">
          <el-input v-model="form.ord" placeholder="请输入排序" />
        </el-form-item>
        <el-form-item label="${comment}" prop="isDel">
          <el-input v-model="form.isDel" placeholder="请输入${comment}" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <standardDlg ref="dlg" @success="loadData"></standardDlg>
  </div>
</template>

<script>
import { listProjectStandard, getProjectStandard, delProjectStandard, addProjectStandard, updateProjectStandard } from "@/api/project/projectStandard";
import standardTypes from './standardType'
import standardDlg from './projectStandardDlg.vue'
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
export default {
  name: "ProjectStandard",
  components: {
    Treeselect,standardDlg
    },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 标准化管理表格数据
      projectStandardList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        projectId: null,
        deptId: null,
        imageFile: null,
        standardDesc: null,
        ord: null,
        standardType: null,
        isDel: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      treeOpts:[],
      options: standardTypes,
      projectOptions:[],
      depts: [],
    };
  },
  created() {
    this.getList();
    standardTypes.forEach(it=>{
            this.treeOpts.push(it);
            if(it.children){
                it.children.forEach(it2=>{
                    this.treeOpts.push(it2);
                    if(it2.children){
                        it2.children.forEach(it3=>{
                            this.treeOpts.push(it3);
                        })
                    }
                })
            }
        });
    this.$api.publics.getMyProjectList({}).then((response) => {
        this.projectOptions = response.rows;
    });          
  },
  methods: {
    doQuerySub() {
      let prjId=this.queryParams.projectId;      
      let tmps = this.prjDept2 && this.prjDept2[prjId] ? this.prjDept2[prjId] || [] : [];
      if (tmps.length > 0 || !prjId) {
        this.depts = tmps;
        if (tmps.length == 1) {
          this.queryParams.subDeptId = tmps[0].deptId;
        } else {
          this.queryParams.subDeptId = '';
        }
        return;
      }
      this.$api.publics.queryUnitList({
        projectId: prjId,
        unitTypes: "2".split(","),
      }).then((d) => {
        let objs = d.rows || [];
        if (!this.prjDept2) {
          this.prjDept2 = {};
        }
        this.prjDept2[prjId] = objs;
        this.depts = objs;
        if (objs.length == 1) {
          this.queryParams.subDeptId = objs[0].deptId;
        } else {
          this.queryParams.subDeptId = '';
        }
      });
    },
    doRowSelect(row,a){
      setTimeout(()=>{        
        if(a.children && a.children.length>0){
          row.standardType=row.oldStandardType;
        }else{
          updateProjectStandard(row).then(d=>{
            this.$modal.msgSuccess("更新成功");
          })
        }
      },400);
    },
    getType(row) {
            let t = row.standardType || 1;
            let tmps = this.treeOpts.filter(d => d.id == t);
            return tmps.length > 0 ? tmps[0].label : '';
        },
    /** 查询标准化管理列表 */
    getList() {
      this.loading = true;
      listProjectStandard(this.queryParams).then(response => {
        this.projectStandardList = (response.rows||[]).map(it=>{
          it.oldStandardType=it.standardType;
          return it;
        });
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        projectId: null,
        deptId: null,
        imageFile: null,
        desc: null,
        ord: null,
        standardType: null,
        isDel: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    handleEdit(row) {
            let tmps = this.depts.filter(d => d.deptId == this.activeName);
            this.$refs.dlg.showDialog(this.prj, tmps.length > 0 ? tmps[0] : {}, row);
      },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加标准化管理";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getProjectStandard(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改标准化管理";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id) {
            updateProjectStandard(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addProjectStandard(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除标准化管理编号为"' + ids + '"的数据项？').then(function () {
        return delProjectStandard(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('project/projectStandard/export', {
        ...this.queryParams
      }, `projectStandard_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
<style lang="scss">
.project-standard-index{
.td-tree-select{
  .cell{
    overflow: visible;
  }
}
}
</style>